/*
 * NOTICE OF LICENSE
 *
 * @author    INVERTUS, UAB www.invertus.eu <support@invertus.eu>
 * @copyright Copyright (c) permanent, INVERTUS, UAB
 * @license   Addons PrestaShop license limitation
 * @see       /LICENSE
 *
 * International Registered Trademark & Property of INVERTUS, UAB
 */

$(document).ready(function () {
    hideConfigurationForm();

    $('#sendRequestBtn').on('click', function (e) {
        hideError();
        hideSuccess();

        e.preventDefault();
        e.stopPropagation();

        var company = $('#InquryCompanyName').val();
        var companyCode = $('#InquryCompanyCode').val();
        var name = $('#InquryName').val();
        var phone = $('#InquryPhone').val();
        var email = $('#InquryEmail').val();
        var storeUrl = $('#InquryEshopUrl').val();

        if (!company || !companyCode || !name || !phone || !email || !storeUrl) {
            showError(swedbank.messages.error.all_fields_required);
            return;
        }

        $('#setPl').val('prestashop_'+$('#countryCode').val());

        $.ajax('https://ib.swedbank.lt/private/mail/sender', {
            type: 'POST',
            data: $('#requestForm').serialize(),
            error: function (xhr) {
                if (xhr.status > 500) {
                    showError(swedbank.messages.error.failed_send);
                    return;
                }

                showSuccess(swedbank.messages.success.request_sent);
            }
        });
    });

    function showError(message)
    {
        var $errorBlock = $('#errorBlock');
        $errorBlock.html(message);
        $errorBlock.removeClass('hidden');
    }

    function hideError()
    {
        var $errorBlock = $('#errorBlock');
        $errorBlock.empty();
        $errorBlock.addClass('hidden');
    }

    function showSuccess(message)
    {
        var $errorBlock = $('#successBlock');
        $errorBlock.html(message);
        $errorBlock.removeClass('hidden');
    }

    function hideSuccess()
    {
        var $errorBlock = $('#successBlock');
        $errorBlock.empty();
        $errorBlock.addClass('hidden');
    }

    /**
     * Hide default configuration form in PS 1.5
     */
    function hideConfigurationForm() {
        var $configurationForm = $('#configuration_form');

        if ($configurationForm.length) {
            $configurationForm.remove();
        }
    }
});
